#include "mapitem.h"

#include "linkablemapobj.h"
#include "ornamentedobj.h"

MapItem::MapItem()
{
	init();
}

void MapItem::init()
{
	lmo=NULL;
	posMode=Unused;
}

void MapItem::setRelPos (const QPointF &p)
{
	posMode=Relative;
	pos=p;
	if (lmo)
	{
		((OrnamentedObj*)lmo)->setUseRelPos (true);
		((OrnamentedObj*)lmo)->move2RelPos(p);
	}
}

void MapItem::setAbsPos (const QPointF &p)
{
	posMode=Absolute;
	pos=p;
	if (lmo) lmo->move (p);
}

void MapItem::setPositionMode (PositionMode mode)
{
	posMode=mode;
}

LinkableMapObj* MapItem::getLMO()
{
	return lmo;
}

void MapItem::setLMO(LinkableMapObj *l)
{
	lmo=l;
}

void MapItem::initLMO()
{
	if (!lmo) return;
	switch (posMode)
	{
		case Relative:	
			lmo->setRelPos (pos);
			break;
		case Absolute:	
			lmo->move (pos);
			break;
		default:
			break;
	}
}

